//Dieses Programm berechnet die minimalen Standarderzeugendensystem der Untergruppen
//der Signatur (2;-) von arithmetischen Gruppen der Signatur (0;3,3,3,3) durch Angabe des
//entsprechenden Spurtupels. Einzugeben sind die Werte fr rho, s, t wie in
//Abschnitt 3.2.3 beschrieben. Die Ausgabe erfolgt als Kombination in rho (dem
//ber Q primitiven Element von k).


package test;

import Algebra.*;

public class Testlauf3333 {

  public static void main(String[] args) {
//Hier die Werte fr rho, s, t eingeben:
    double rho = 3.31651242917313233044656765963;
    double rhi = -1/rho;
    double s = 3.26032371402763347064779464313;
    double t = 4.23606797749978969639808249593;
    double[] a = {0.0, 1.0, -1.0, 1.0};
    double[] b = {0.0, rho, rhi, 1.0};
    double[] c = {s, t, (s-s*s-1)/t, 1-s};
//Hier den Krpergrad angeben. Es werden die Darstellungen der y[ij]
//als ganze Zahlen berechnet
    int Koerpergrad = 2;
//Hier den Nenner angeben, der bei Ganzheitsbasis auftaucht:
    int Nenner = 2;
    GanzeZahl G = new GanzeZahl(Koerpergrad);
// Hier die Koeffizienten des erzeugenden Polynoms angeben, jeweils durch
// Komma voneinander getrennt. An erster Stelle den von x.hoch.0 angeben,
// ..., an n-ter Stelle den von x.hoch.n-1.
    long[] f = {-5,0};
    G.initialf(f);
// Hier die Nullstellen des erzeugenden Polynoms angeben, jeweils durch
// ein Komma getrennt. Die erste Nullstelle ist das ber Q primitive Element
// des Krpers.
    double[] NS = {Math.sqrt(5), -Math.sqrt(5)};
    G.initialNS(NS);


    double[] d = new double[4];
    d = Rechnen.MM(a,Rechnen.MM(b,c));
    System.out.println(c[0]+","+c[1]+","+c[2]+","+c[3]);
    System.out.println(d[0]+","+d[1]+","+d[2]+","+d[3]);
    System.out.println(Rechnen.Trace(d));
    double[][] A = new double[3][4];
    double[][] B = new double[3][4];
    double[][] C = new double[3][4];
    double[][] D = new double[3][4];


    A[0] = Rechnen.MM(Rechnen.inv(c),Rechnen.MM(a,b));
    B[0] = Rechnen.MM(Rechnen.inv(b),Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(b),Rechnen.MM(Rechnen.inv(a),Rechnen.inv(c)))));
    C[0] = Rechnen.MM(b,Rechnen.inv(a));
    D[0] = Rechnen.MM(a,Rechnen.MM(b,a));
    double[] te = Rechnen.MM(A[0],Rechnen.MM(B[0],Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]), Rechnen.MM(C[0],Rechnen.MM(D[0],Rechnen.MM(Rechnen.inv(C[0]),Rechnen.inv(D[0]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);


    A[1] = Rechnen.MM(Rechnen.inv(a),Rechnen.inv(b));
    B[1] = Rechnen.MM(Rechnen.inv(b),Rechnen.MM(c,a));
    C[1] = Rechnen.MM(Rechnen.inv(b),Rechnen.inv(a));
    D[1] = Rechnen.MM(a,Rechnen.inv(c));
    te = Rechnen.MM(A[1],Rechnen.MM(B[1],Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]), Rechnen.MM(C[1],Rechnen.MM(D[1],Rechnen.MM(Rechnen.inv(C[1]),Rechnen.inv(D[1]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);


    A[2] = Rechnen.MM(b,Rechnen.inv(c));
    B[2] = Rechnen.MM(Rechnen.inv(c),Rechnen.MM(a,Rechnen.inv(b)));
    C[2] = Rechnen.MM(Rechnen.inv(c),Rechnen.inv(a));
    D[2] = Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(c),Rechnen.MM(Rechnen.inv(b),Rechnen.inv(a))));
    te = Rechnen.MM(A[2],Rechnen.MM(B[2],Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]), Rechnen.MM(C[2],Rechnen.MM(D[2],Rechnen.MM(Rechnen.inv(C[2]),Rechnen.inv(D[2]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    double[][] q = new double[6][7];
    for (byte i=0; i<7; i++)
      q[0][i] = 0;
    for (byte i=0; i<2; i++)
      q[1][i] = 0;
    for (byte i=0; i<3; i++)
      q[2][i] = 0;
    for (byte i=0; i<4; i++)
      q[3][i] = 0;
    for (byte i=0; i<5; i++)
      q[4][i] = 0;
    for (byte i=0; i<6; i++)
      q[5][i] = 0;


    q[1][2] = Rechnen.Trace(A[0])*Rechnen.Trace(A[0]);
    q[1][3] = Rechnen.Trace(B[0])*Rechnen.Trace(B[0]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0], D[0]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],D[0]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0], Rechnen.MM(D[0],C[0])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0], Rechnen.MM(D[0],C[0])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]), C[0])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),C[0])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[0],B[0]))*Rechnen.Trace(Rechnen.MM(A[0],B[0]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],D[0])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],D[0])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],Rechnen.MM(D[0],C[0]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],Rechnen.MM(D[0],C[0]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),C[0]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),C[0]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[0]),Rechnen.MM(Rechnen.inv(D[0]), A[0])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[0]),Rechnen.MM(Rechnen.inv(D[0]),A[0])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(D[0],Rechnen.MM(C[0], C[0]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(D[0],Rechnen.MM(C[0],C[0]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[0],Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),C[0]))))*Rechnen.Trace(Rechnen.MM(B[0],Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),C[0]))));
    q[4][5] = Rechnen.Trace(C[0])*Rechnen.Trace(C[0]);
    q[4][6] = Rechnen.Trace(D[0])*Rechnen.Trace(D[0]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[0],D[0]))*Rechnen.Trace(Rechnen.MM(C[0],D[0]));



//Wurzelziehen:
    double[][] y = new double[6][7];
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
    System.out.println("Die Werte:");System.out.println();
// Achtung: Kurzversion! Normalform berechen:
    NormalRechnen sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.println("als ganze Zahlen:");
    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[1])*Rechnen.Trace(A[1]);
    q[1][3] = Rechnen.Trace(B[1])*Rechnen.Trace(B[1]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1], D[1]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],D[1]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1], Rechnen.MM(D[1],C[1])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1], Rechnen.MM(D[1],C[1])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]), C[1])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),C[1])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[1],B[1]))*Rechnen.Trace(Rechnen.MM(A[1],B[1]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],D[1])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],D[1])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],Rechnen.MM(D[1],C[1]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],Rechnen.MM(D[1],C[1]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),C[1]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),C[1]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[1]),Rechnen.MM(Rechnen.inv(D[1]), A[1])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[1]),Rechnen.MM(Rechnen.inv(D[1]),A[1])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(D[1],Rechnen.MM(C[1], C[1]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(D[1],Rechnen.MM(C[1],C[1]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[1],Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),C[1]))))*Rechnen.Trace(Rechnen.MM(B[1],Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),C[1]))));
    q[4][5] = Rechnen.Trace(C[1])*Rechnen.Trace(C[1]);
    q[4][6] = Rechnen.Trace(D[1])*Rechnen.Trace(D[1]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[1],D[1]))*Rechnen.Trace(Rechnen.MM(C[1],D[1]));


//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");




    q[1][2] = Rechnen.Trace(A[2])*Rechnen.Trace(A[2]);
    q[1][3] = Rechnen.Trace(B[2])*Rechnen.Trace(B[2]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2], D[2]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],D[2]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2], Rechnen.MM(D[2],C[2])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2], Rechnen.MM(D[2],C[2])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]), C[2])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),C[2])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[2],B[2]))*Rechnen.Trace(Rechnen.MM(A[2],B[2]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],D[2])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],D[2])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],Rechnen.MM(D[2],C[2]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],Rechnen.MM(D[2],C[2]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),C[2]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),C[2]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[2]),Rechnen.MM(Rechnen.inv(D[2]), A[2])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[2]),Rechnen.MM(Rechnen.inv(D[2]),A[2])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(D[2],Rechnen.MM(C[2], C[2]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(D[2],Rechnen.MM(C[2],C[2]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[2],Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),C[2]))))*Rechnen.Trace(Rechnen.MM(B[2],Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),C[2]))));
    q[4][5] = Rechnen.Trace(C[2])*Rechnen.Trace(C[2]);
    q[4][6] = Rechnen.Trace(D[2])*Rechnen.Trace(D[2]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[2],D[2]))*Rechnen.Trace(Rechnen.MM(C[2],D[2]));



//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");



 
  }
   

}

