//Dieses Programm berechnet die minimalen Standarderzeugendensystem der Untergruppen
//der Signatur (2;-) von arithmetischen Gruppen der Signatur (1;2) durch Angabe des
//entsprechenden Spurtupels. Einzugeben sind die Werte fr rho, x, y wie in
//Abschnitt 3.2.1 beschrieben. Die Ausgabe erfolgt als Kombination in rho (dem
//ber Q primitiven Element von k). In einigen Fllen liefert das Programm aufgrund von
//Rundungsfehlern keine Ergebnisse. In diesem Fall ist das Ursprungstupel
//(y[12],...,y[56]) z.B. mit Maple zu berechnen und in das Programm Normalform.java
//einzugeben.

package test;

import Algebra.*;

public class Testlauf3 {

  public static void main(String[] args) {
//Hier die Werte fr rho, x, y eingeben:
    double x = 2.28824561127073719040029113432;
    double y = 3.23606797749978969640917366873;
    double rho = 3.40912912887359869089742887619;
    double[] a = {0.0, 1.0, -1.0, x};
    double[] b = {0.0, rho, -1/rho, y};
//Hier den Krpergrad angeben. Es werden die Darstellungen der y[ij]
//als ganze Zahlen berechnet
    int Koerpergrad = 2;
//Hier den Nenner angeben, der bei Ganzheitsbasis auftaucht:
    int Nenner = 2;
    GanzeZahl G = new GanzeZahl(Koerpergrad);
// Hier die Koeffizienten des erzeugenden Polynoms angeben, jeweils durch
// Komma voneinander getrennt. An erster Stelle den von x.hoch.0 angeben,
// ..., an n-ter Stelle den von x.hoch.n-1.
    long[] f = {-5, 0};
    G.initialf(f);
// Hier die Nullstellen des erzeugenden Polynoms angeben, jeweils durch
// ein Komma getrennt. Die erste Nullstelle ist das ber Q primitive Element
// des Krpers.
    double[] NS = {Math.sqrt(5), -Math.sqrt(5)};
    G.initialNS(NS);


    double[] p = new double[4];
    double[] r = new double[4];
    p = Rechnen.inv(Rechnen.MM(a,Rechnen.MM(b,Rechnen.MM(Rechnen.inv(a),Rechnen.inv(b)))));
    r = Rechnen.MM(a,b);
    System.out.println(p[0]+","+p[1]+","+p[2]+","+p[3]);
    System.out.println(r[0]+","+r[1]+","+r[2]+","+r[3]);
    System.out.println(a[0]+","+a[1]+","+a[2]+","+a[3]);
    System.out.println(Rechnen.Trace(p));
    double[][] A = new double[10][4];
    double[][] B = new double[10][4];
    double[][] C = new double[10][4];
    double[][] D = new double[10][4];
    A[0] = a;
    B[0] = Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(a,b))));
    C[0] = Rechnen.MM(Rechnen.inv(a),Rechnen.MM(p,Rechnen.inv(b)));
    D[0] = Rechnen.MM(b,Rechnen.MM(Rechnen.inv(p),Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(a, Rechnen.MM(a,Rechnen.inv(b)))))));
    double[] te = Rechnen.MM(A[0],Rechnen.MM(B[0],Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]), Rechnen.MM(C[0],Rechnen.MM(D[0],Rechnen.MM(Rechnen.inv(C[0]),Rechnen.inv(D[0]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);


    A[1] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(a),Rechnen.inv(b)));
    B[1] = Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(p,Rechnen.MM(b,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(a),p))))));
    C[1] = Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(p,Rechnen.MM(Rechnen.inv(b),Rechnen.inv(b)))));
    D[1] = Rechnen.MM(b,Rechnen.MM(b,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(b),Rechnen.inv(b)))));
    te = Rechnen.MM(A[1],Rechnen.MM(B[1],Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]), Rechnen.MM(C[1],Rechnen.MM(D[1],Rechnen.MM(Rechnen.inv(C[1]),Rechnen.inv(D[1]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    A[2] = Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(b,p)));
    B[2] = Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(a,Rechnen.MM(Rechnen.inv(b),Rechnen.inv(a)))));
    C[2] = Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(a,Rechnen.MM(Rechnen.inv(b),Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(a),Rechnen.inv(b)))))))));
    D[2] = Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(a,Rechnen.MM(b,Rechnen.MM(b,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(a),Rechnen.inv(b))))))));
    te = Rechnen.MM(A[2],Rechnen.MM(B[2],Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]), Rechnen.MM(C[2],Rechnen.MM(D[2],Rechnen.MM(Rechnen.inv(C[2]),Rechnen.inv(D[2]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    A[3] = a;
    B[3] = Rechnen.MM(b,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(b),Rechnen.MM(p,Rechnen.MM(Rechnen.inv(b),Rechnen.MM(a,b)))))));
    C[3] = Rechnen.MM(b,Rechnen.MM(b,p));
    D[3] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(b),Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(a),Rechnen.inv(b)))));
    te = Rechnen.MM(A[3],Rechnen.MM(B[3],Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(B[3]),
Rechnen.MM(C[3],Rechnen.MM(D[3],Rechnen.MM(Rechnen.inv(C[3]),Rechnen.inv(D[3]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    A[4] = Rechnen.MM(Rechnen.inv(b),Rechnen.MM(Rechnen.inv(a),Rechnen.inv(b)));
    B[4] = Rechnen.MM(p,Rechnen.MM(a,Rechnen.inv(b)));
    C[4] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(a),b));
    D[4] = Rechnen.MM(Rechnen.inv(b),Rechnen.MM(a,Rechnen.MM(a,Rechnen.MM(Rechnen.inv(b),Rechnen.inv(a)))));
    te = Rechnen.MM(A[4],Rechnen.MM(B[4],Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(B[4]), Rechnen.MM(C[4],Rechnen.MM(D[4],Rechnen.MM(Rechnen.inv(C[4]),Rechnen.inv(D[4]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    A[5] = Rechnen.MM(a,Rechnen.MM(b,p));
    B[5] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(b),Rechnen.MM(Rechnen.inv(b),Rechnen.MM(a,p))));
    C[5] = b;
    D[5] = Rechnen.MM(Rechnen.inv(b),Rechnen.MM(p,Rechnen.MM(Rechnen.inv(b),a)));
    te = Rechnen.MM(A[5],Rechnen.MM(B[5],Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(B[5]), Rechnen.MM(C[5],Rechnen.MM(D[5],Rechnen.MM(Rechnen.inv(C[5]),Rechnen.inv(D[5]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    A[6] = Rechnen.MM(a,a);
    B[6] = Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(p,Rechnen.MM(a,Rechnen.MM(b,Rechnen.MM(b,Rechnen.inv(a))))))));
    C[6] = Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(a,p)));
    D[6] = Rechnen.MM(a,Rechnen.MM(b,Rechnen.MM(b,Rechnen.MM(a,Rechnen.inv(b)))));
    te = Rechnen.MM(A[6],Rechnen.MM(B[6],Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(B[6]), Rechnen.MM(C[6],Rechnen.MM(D[6],Rechnen.MM(Rechnen.inv(C[6]),Rechnen.inv(D[6]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    A[7] = Rechnen.MM(a,Rechnen.MM(b,a));
    B[7] = Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.inv(a)));
    C[7] = Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(a,p)));
    D[7] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(a,Rechnen.inv(b)))));
    te = Rechnen.MM(A[7],Rechnen.MM(B[7],Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(B[7]), Rechnen.MM(C[7],Rechnen.MM(D[7],Rechnen.MM(Rechnen.inv(C[7]),Rechnen.inv(D[7]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    A[8] = Rechnen.MM(a,Rechnen.MM(b,p));
    B[8] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(Rechnen.inv(a),Rechnen.inv(b)))));
    C[8] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(b),Rechnen.MM(a,p)))))));
    D[8] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(a),Rechnen.MM(b,Rechnen.MM(a,Rechnen.MM(Rechnen.inv(b),Rechnen.MM(Rechnen.inv(b),Rechnen.MM(a,p)))))));
    te = Rechnen.MM(A[8],Rechnen.MM(B[8],Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(B[8]), Rechnen.MM(C[8],Rechnen.MM(D[8],Rechnen.MM(Rechnen.inv(C[8]),Rechnen.inv(D[8]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);



    A[9] = Rechnen.MM(p,Rechnen.MM(Rechnen.inv(a),b));
    B[9] = Rechnen.MM(Rechnen.inv(b),Rechnen.MM(Rechnen.inv(b),Rechnen.MM(p,Rechnen.MM(a,Rechnen.MM(a,Rechnen.MM(b,Rechnen.inv(a)))))));
    C[9] = Rechnen.MM(Rechnen.inv(a),Rechnen.MM(Rechnen.inv(a),p));
    D[9] = Rechnen.MM(p,Rechnen.MM(a,Rechnen.MM(a,Rechnen.MM(Rechnen.inv(b),Rechnen.inv(b)))));
    te = Rechnen.MM(A[9],Rechnen.MM(B[9],Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(B[9]), Rechnen.MM(C[9],Rechnen.MM(D[9],Rechnen.MM(Rechnen.inv(C[9]),Rechnen.inv(D[9]))))))));
    System.out.println(te[0]+","+te[1]+","+te[2]+","+te[3]);




    


    double[][] q = new double[6][7];
    for (byte i=0; i<7; i++)
      q[0][i] = 0;
    for (byte i=0; i<2; i++)
      q[1][i] = 0;
    for (byte i=0; i<3; i++)
      q[2][i] = 0;
    for (byte i=0; i<4; i++)
      q[3][i] = 0;
    for (byte i=0; i<5; i++)
      q[4][i] = 0;
    for (byte i=0; i<6; i++)
      q[5][i] = 0;


    q[1][2] = Rechnen.Trace(A[0])*Rechnen.Trace(A[0]);
    q[1][3] = Rechnen.Trace(B[0])*Rechnen.Trace(B[0]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0], D[0]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],D[0]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0], Rechnen.MM(D[0],C[0])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0], Rechnen.MM(D[0],C[0])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]), C[0])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(B[0]),C[0])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[0],B[0]))*Rechnen.Trace(Rechnen.MM(A[0],B[0]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],D[0])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],D[0])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],Rechnen.MM(D[0],C[0]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),Rechnen.MM(C[0],Rechnen.MM(D[0],C[0]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),C[0]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),C[0]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[0]),Rechnen.MM(Rechnen.inv(D[0]), A[0])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[0]),Rechnen.MM(Rechnen.inv(D[0]),A[0])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(D[0],Rechnen.MM(C[0], C[0]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[0]),Rechnen.MM(D[0],Rechnen.MM(C[0],C[0]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[0],Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),C[0]))))*Rechnen.Trace(Rechnen.MM(B[0],Rechnen.MM(Rechnen.inv(A[0]), Rechnen.MM(Rechnen.inv(B[0]),C[0]))));
    q[4][5] = Rechnen.Trace(C[0])*Rechnen.Trace(C[0]);
    q[4][6] = Rechnen.Trace(D[0])*Rechnen.Trace(D[0]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[0],D[0]))*Rechnen.Trace(Rechnen.MM(C[0],D[0]));



//Wurzelziehen:
    double[][] y = new double[6][7];
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
    System.out.println("Die Werte:");System.out.println();
// Achtung: Kurzversion! Normalform berechen:
    NormalRechnen sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.println("als ganze Zahlen:");
    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[1])*Rechnen.Trace(A[1]);
    q[1][3] = Rechnen.Trace(B[1])*Rechnen.Trace(B[1]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1], D[1]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],D[1]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1], Rechnen.MM(D[1],C[1])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1], Rechnen.MM(D[1],C[1])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]), C[1])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(B[1]),C[1])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[1],B[1]))*Rechnen.Trace(Rechnen.MM(A[1],B[1]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],D[1])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],D[1])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],Rechnen.MM(D[1],C[1]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),Rechnen.MM(C[1],Rechnen.MM(D[1],C[1]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),C[1]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),C[1]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[1]),Rechnen.MM(Rechnen.inv(D[1]), A[1])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[1]),Rechnen.MM(Rechnen.inv(D[1]),A[1])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(D[1],Rechnen.MM(C[1], C[1]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[1]),Rechnen.MM(D[1],Rechnen.MM(C[1],C[1]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[1],Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),C[1]))))*Rechnen.Trace(Rechnen.MM(B[1],Rechnen.MM(Rechnen.inv(A[1]), Rechnen.MM(Rechnen.inv(B[1]),C[1]))));
    q[4][5] = Rechnen.Trace(C[1])*Rechnen.Trace(C[1]);
    q[4][6] = Rechnen.Trace(D[1])*Rechnen.Trace(D[1]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[1],D[1]))*Rechnen.Trace(Rechnen.MM(C[1],D[1]));


//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[2])*Rechnen.Trace(A[2]);
    q[1][3] = Rechnen.Trace(B[2])*Rechnen.Trace(B[2]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2], D[2]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],D[2]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2], Rechnen.MM(D[2],C[2])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2], Rechnen.MM(D[2],C[2])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]), C[2])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(B[2]),C[2])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[2],B[2]))*Rechnen.Trace(Rechnen.MM(A[2],B[2]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],D[2])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],D[2])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],Rechnen.MM(D[2],C[2]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),Rechnen.MM(C[2],Rechnen.MM(D[2],C[2]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),C[2]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),C[2]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[2]),Rechnen.MM(Rechnen.inv(D[2]), A[2])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[2]),Rechnen.MM(Rechnen.inv(D[2]),A[2])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(D[2],Rechnen.MM(C[2], C[2]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[2]),Rechnen.MM(D[2],Rechnen.MM(C[2],C[2]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[2],Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),C[2]))))*Rechnen.Trace(Rechnen.MM(B[2],Rechnen.MM(Rechnen.inv(A[2]), Rechnen.MM(Rechnen.inv(B[2]),C[2]))));
    q[4][5] = Rechnen.Trace(C[2])*Rechnen.Trace(C[2]);
    q[4][6] = Rechnen.Trace(D[2])*Rechnen.Trace(D[2]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[2],D[2]))*Rechnen.Trace(Rechnen.MM(C[2],D[2]));



//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[3])*Rechnen.Trace(A[3]);
    q[1][3] = Rechnen.Trace(B[3])*Rechnen.Trace(B[3]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(B[3]),Rechnen.MM(C[3], D[3]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(B[3]),Rechnen.MM(C[3],D[3]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(B[3]),Rechnen.MM(C[3], Rechnen.MM(D[3],C[3])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(B[3]),Rechnen.MM(C[3], Rechnen.MM(D[3],C[3])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(B[3]), C[3])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(B[3]),C[3])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[3],B[3]))*Rechnen.Trace(Rechnen.MM(A[3],B[3]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(A[3]), Rechnen.MM(Rechnen.inv(B[3]),Rechnen.MM(C[3],D[3])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(A[3]), Rechnen.MM(Rechnen.inv(B[3]),Rechnen.MM(C[3],D[3])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(A[3]), Rechnen.MM(Rechnen.inv(B[3]),Rechnen.MM(C[3],Rechnen.MM(D[3],C[3]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(A[3]), Rechnen.MM(Rechnen.inv(B[3]),Rechnen.MM(C[3],Rechnen.MM(D[3],C[3]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(A[3]), Rechnen.MM(Rechnen.inv(B[3]),C[3]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(Rechnen.inv(A[3]), Rechnen.MM(Rechnen.inv(B[3]),C[3]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[3]),Rechnen.MM(Rechnen.inv(D[3]), A[3])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[3]),Rechnen.MM(Rechnen.inv(D[3]),A[3])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(D[3],Rechnen.MM(C[3], C[3]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[3]),Rechnen.MM(D[3],Rechnen.MM(C[3],C[3]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[3],Rechnen.MM(Rechnen.inv(A[3]), Rechnen.MM(Rechnen.inv(B[3]),C[3]))))*Rechnen.Trace(Rechnen.MM(B[3],Rechnen.MM(Rechnen.inv(A[3]), Rechnen.MM(Rechnen.inv(B[3]),C[3]))));
    q[4][5] = Rechnen.Trace(C[3])*Rechnen.Trace(C[3]);
    q[4][6] = Rechnen.Trace(D[3])*Rechnen.Trace(D[3]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[3],D[3]))*Rechnen.Trace(Rechnen.MM(C[3],D[3]));



//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[4])*Rechnen.Trace(A[4]);
    q[1][3] = Rechnen.Trace(B[4])*Rechnen.Trace(B[4]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(B[4]),Rechnen.MM(C[4], D[4]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(B[4]),Rechnen.MM(C[4],D[4]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(B[4]),Rechnen.MM(C[4], Rechnen.MM(D[4],C[4])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(B[4]),Rechnen.MM(C[4], Rechnen.MM(D[4],C[4])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(B[4]), C[4])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(B[4]),C[4])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[4],B[4]))*Rechnen.Trace(Rechnen.MM(A[4],B[4]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(A[4]), Rechnen.MM(Rechnen.inv(B[4]),Rechnen.MM(C[4],D[4])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(A[4]), Rechnen.MM(Rechnen.inv(B[4]),Rechnen.MM(C[4],D[4])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(A[4]), Rechnen.MM(Rechnen.inv(B[4]),Rechnen.MM(C[4],Rechnen.MM(D[4],C[4]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(A[4]), Rechnen.MM(Rechnen.inv(B[4]),Rechnen.MM(C[4],Rechnen.MM(D[4],C[4]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(A[4]), Rechnen.MM(Rechnen.inv(B[4]),C[4]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(Rechnen.inv(A[4]), Rechnen.MM(Rechnen.inv(B[4]),C[4]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[4]),Rechnen.MM(Rechnen.inv(D[4]), A[4])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[4]),Rechnen.MM(Rechnen.inv(D[4]),A[4])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(D[4],Rechnen.MM(C[4], C[4]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[4]),Rechnen.MM(D[4],Rechnen.MM(C[4],C[4]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[4],Rechnen.MM(Rechnen.inv(A[4]), Rechnen.MM(Rechnen.inv(B[4]),C[4]))))*Rechnen.Trace(Rechnen.MM(B[4],Rechnen.MM(Rechnen.inv(A[4]), Rechnen.MM(Rechnen.inv(B[4]),C[4]))));
    q[4][5] = Rechnen.Trace(C[4])*Rechnen.Trace(C[4]);
    q[4][6] = Rechnen.Trace(D[4])*Rechnen.Trace(D[4]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[4],D[4]))*Rechnen.Trace(Rechnen.MM(C[4],D[4]));


          

//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[5])*Rechnen.Trace(A[5]);
    q[1][3] = Rechnen.Trace(B[5])*Rechnen.Trace(B[5]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(B[5]),Rechnen.MM(C[5], D[5]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(B[5]),Rechnen.MM(C[5],D[5]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(B[5]),Rechnen.MM(C[5], Rechnen.MM(D[5],C[5])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(B[5]),Rechnen.MM(C[5], Rechnen.MM(D[5],C[5])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(B[5]), C[5])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(B[5]),C[5])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[5],B[5]))*Rechnen.Trace(Rechnen.MM(A[5],B[5]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(A[5]), Rechnen.MM(Rechnen.inv(B[5]),Rechnen.MM(C[5],D[5])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(A[5]), Rechnen.MM(Rechnen.inv(B[5]),Rechnen.MM(C[5],D[5])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(A[5]), Rechnen.MM(Rechnen.inv(B[5]),Rechnen.MM(C[5],Rechnen.MM(D[5],C[5]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(A[5]), Rechnen.MM(Rechnen.inv(B[5]),Rechnen.MM(C[5],Rechnen.MM(D[5],C[5]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(A[5]), Rechnen.MM(Rechnen.inv(B[5]),C[5]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(Rechnen.inv(A[5]), Rechnen.MM(Rechnen.inv(B[5]),C[5]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[5]),Rechnen.MM(Rechnen.inv(D[5]), A[5])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[5]),Rechnen.MM(Rechnen.inv(D[5]),A[5])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(D[5],Rechnen.MM(C[5], C[5]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[5]),Rechnen.MM(D[5],Rechnen.MM(C[5],C[5]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[5],Rechnen.MM(Rechnen.inv(A[5]), Rechnen.MM(Rechnen.inv(B[5]),C[5]))))*Rechnen.Trace(Rechnen.MM(B[5],Rechnen.MM(Rechnen.inv(A[5]), Rechnen.MM(Rechnen.inv(B[5]),C[5]))));
    q[4][5] = Rechnen.Trace(C[5])*Rechnen.Trace(C[5]);
    q[4][6] = Rechnen.Trace(D[5])*Rechnen.Trace(D[5]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[5],D[5]))*Rechnen.Trace(Rechnen.MM(C[5],D[5]));

          

//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[6])*Rechnen.Trace(A[6]);
    q[1][3] = Rechnen.Trace(B[6])*Rechnen.Trace(B[6]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(B[6]),Rechnen.MM(C[6], D[6]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(B[6]),Rechnen.MM(C[6],D[6]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(B[6]),Rechnen.MM(C[6], Rechnen.MM(D[6],C[6])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(B[6]),Rechnen.MM(C[6], Rechnen.MM(D[6],C[6])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(B[6]), C[6])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(B[6]),C[6])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[6],B[6]))*Rechnen.Trace(Rechnen.MM(A[6],B[6]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(A[6]), Rechnen.MM(Rechnen.inv(B[6]),Rechnen.MM(C[6],D[6])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(A[6]), Rechnen.MM(Rechnen.inv(B[6]),Rechnen.MM(C[6],D[6])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(A[6]), Rechnen.MM(Rechnen.inv(B[6]),Rechnen.MM(C[6],Rechnen.MM(D[6],C[6]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(A[6]), Rechnen.MM(Rechnen.inv(B[6]),Rechnen.MM(C[6],Rechnen.MM(D[6],C[6]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(A[6]), Rechnen.MM(Rechnen.inv(B[6]),C[6]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(Rechnen.inv(A[6]), Rechnen.MM(Rechnen.inv(B[6]),C[6]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[6]),Rechnen.MM(Rechnen.inv(D[6]), A[6])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[6]),Rechnen.MM(Rechnen.inv(D[6]),A[6])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(D[6],Rechnen.MM(C[6], C[6]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[6]),Rechnen.MM(D[6],Rechnen.MM(C[6],C[6]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[6],Rechnen.MM(Rechnen.inv(A[6]), Rechnen.MM(Rechnen.inv(B[6]),C[6]))))*Rechnen.Trace(Rechnen.MM(B[6],Rechnen.MM(Rechnen.inv(A[6]), Rechnen.MM(Rechnen.inv(B[6]),C[6]))));
    q[4][5] = Rechnen.Trace(C[6])*Rechnen.Trace(C[6]);
    q[4][6] = Rechnen.Trace(D[6])*Rechnen.Trace(D[6]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[6],D[6]))*Rechnen.Trace(Rechnen.MM(C[6],D[6]));


       
          

//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();


    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");



    q[1][2] = Rechnen.Trace(A[7])*Rechnen.Trace(A[7]);
    q[1][3] = Rechnen.Trace(B[7])*Rechnen.Trace(B[7]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(B[7]),Rechnen.MM(C[7], D[7]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(B[7]),Rechnen.MM(C[7],D[7]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(B[7]),Rechnen.MM(C[7], Rechnen.MM(D[7],C[7])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(B[7]),Rechnen.MM(C[7], Rechnen.MM(D[7],C[7])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(B[7]), C[7])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(B[7]),C[7])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[7],B[7]))*Rechnen.Trace(Rechnen.MM(A[7],B[7]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(A[7]), Rechnen.MM(Rechnen.inv(B[7]),Rechnen.MM(C[7],D[7])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(A[7]), Rechnen.MM(Rechnen.inv(B[7]),Rechnen.MM(C[7],D[7])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(A[7]), Rechnen.MM(Rechnen.inv(B[7]),Rechnen.MM(C[7],Rechnen.MM(D[7],C[7]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(A[7]), Rechnen.MM(Rechnen.inv(B[7]),Rechnen.MM(C[7],Rechnen.MM(D[7],C[7]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(A[7]), Rechnen.MM(Rechnen.inv(B[7]),C[7]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(Rechnen.inv(A[7]), Rechnen.MM(Rechnen.inv(B[7]),C[7]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[7]),Rechnen.MM(Rechnen.inv(D[7]), A[7])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[7]),Rechnen.MM(Rechnen.inv(D[7]),A[7])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(D[7],Rechnen.MM(C[7], C[7]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[7]),Rechnen.MM(D[7],Rechnen.MM(C[7],C[7]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[7],Rechnen.MM(Rechnen.inv(A[7]), Rechnen.MM(Rechnen.inv(B[7]),C[7]))))*Rechnen.Trace(Rechnen.MM(B[7],Rechnen.MM(Rechnen.inv(A[7]), Rechnen.MM(Rechnen.inv(B[7]),C[7]))));
    q[4][5] = Rechnen.Trace(C[7])*Rechnen.Trace(C[7]);
    q[4][6] = Rechnen.Trace(D[7])*Rechnen.Trace(D[7]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[7],D[7]))*Rechnen.Trace(Rechnen.MM(C[7],D[7]));

         

//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[8])*Rechnen.Trace(A[8]);
    q[1][3] = Rechnen.Trace(B[8])*Rechnen.Trace(B[8]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(B[8]),Rechnen.MM(C[8], D[8]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(B[8]),Rechnen.MM(C[8],D[8]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(B[8]),Rechnen.MM(C[8], Rechnen.MM(D[8],C[8])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(B[8]),Rechnen.MM(C[8], Rechnen.MM(D[8],C[8])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(B[8]), C[8])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(B[8]),C[8])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[8],B[8]))*Rechnen.Trace(Rechnen.MM(A[8],B[8]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(A[8]), Rechnen.MM(Rechnen.inv(B[8]),Rechnen.MM(C[8],D[8])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(A[8]), Rechnen.MM(Rechnen.inv(B[8]),Rechnen.MM(C[8],D[8])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(A[8]), Rechnen.MM(Rechnen.inv(B[8]),Rechnen.MM(C[8],Rechnen.MM(D[8],C[8]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(A[8]), Rechnen.MM(Rechnen.inv(B[8]),Rechnen.MM(C[8],Rechnen.MM(D[8],C[8]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(A[8]), Rechnen.MM(Rechnen.inv(B[8]),C[8]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(Rechnen.inv(A[8]), Rechnen.MM(Rechnen.inv(B[8]),C[8]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[8]),Rechnen.MM(Rechnen.inv(D[8]), A[8])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[8]),Rechnen.MM(Rechnen.inv(D[8]),A[8])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(D[8],Rechnen.MM(C[8], C[8]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[8]),Rechnen.MM(D[8],Rechnen.MM(C[8],C[8]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[8],Rechnen.MM(Rechnen.inv(A[8]), Rechnen.MM(Rechnen.inv(B[8]),C[8]))))*Rechnen.Trace(Rechnen.MM(B[8],Rechnen.MM(Rechnen.inv(A[8]), Rechnen.MM(Rechnen.inv(B[8]),C[8]))));
    q[4][5] = Rechnen.Trace(C[8])*Rechnen.Trace(C[8]);
    q[4][6] = Rechnen.Trace(D[8])*Rechnen.Trace(D[8]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[8],D[8]))*Rechnen.Trace(Rechnen.MM(C[8],D[8]));

          

//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");


    q[1][2] = Rechnen.Trace(A[9])*Rechnen.Trace(A[9]);
    q[1][3] = Rechnen.Trace(B[9])*Rechnen.Trace(B[9]);
    q[1][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(B[9]),Rechnen.MM(C[9], D[9]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(B[9]),Rechnen.MM(C[9],D[9]))));
    q[1][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(B[9]),Rechnen.MM(C[9], Rechnen.MM(D[9],C[9])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(B[9]),Rechnen.MM(C[9], Rechnen.MM(D[9],C[9])))));
    q[1][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(B[9]), C[9])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(B[9]),C[9])));
    q[2][3] = Rechnen.Trace(Rechnen.MM(A[9],B[9]))*Rechnen.Trace(Rechnen.MM(A[9],B[9]));
    q[2][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(A[9]), Rechnen.MM(Rechnen.inv(B[9]),Rechnen.MM(C[9],D[9])))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(A[9]), Rechnen.MM(Rechnen.inv(B[9]),Rechnen.MM(C[9],D[9])))));
    q[2][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(A[9]), Rechnen.MM(Rechnen.inv(B[9]),Rechnen.MM(C[9],Rechnen.MM(D[9],C[9]))))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(A[9]), Rechnen.MM(Rechnen.inv(B[9]),Rechnen.MM(C[9],Rechnen.MM(D[9],C[9]))))));
    q[2][6] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(A[9]), Rechnen.MM(Rechnen.inv(B[9]),C[9]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(Rechnen.inv(A[9]), Rechnen.MM(Rechnen.inv(B[9]),C[9]))));
    q[3][4] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[9]),Rechnen.MM(Rechnen.inv(D[9]), A[9])))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(C[9]),Rechnen.MM(Rechnen.inv(D[9]),A[9])));
    q[3][5] = Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(D[9],Rechnen.MM(C[9], C[9]))))*Rechnen.Trace(Rechnen.MM(Rechnen.inv(A[9]),Rechnen.MM(D[9],Rechnen.MM(C[9],C[9]))));
    q[3][6] = Rechnen.Trace(Rechnen.MM(B[9],Rechnen.MM(Rechnen.inv(A[9]), Rechnen.MM(Rechnen.inv(B[9]),C[9]))))*Rechnen.Trace(Rechnen.MM(B[9],Rechnen.MM(Rechnen.inv(A[9]), Rechnen.MM(Rechnen.inv(B[9]),C[9]))));
    q[4][5] = Rechnen.Trace(C[9])*Rechnen.Trace(C[9]);
    q[4][6] = Rechnen.Trace(D[9])*Rechnen.Trace(D[9]);
    q[5][6] = Rechnen.Trace(Rechnen.MM(C[9],D[9]))*Rechnen.Trace(Rechnen.MM(C[9],D[9]));

     
          

//Wurzelziehen:
    for (byte i=0; i<6; i++)
      for (byte j=0; j<7; j++)
        y[i][j] = Math.sqrt(q[i][j]);
// Normalform berechen:
    sp = new NormalRechnen(y);
    sp.Methode45();

    System.out.print("$(");
    G.Berechne(Nenner*sp.gib(1,2)*sp.gib(1,2),1,2,Nenner);
    G.Berechne(Nenner*sp.gib(1,3)*sp.gib(1,3),1,3,Nenner);
    G.Berechne(Nenner*sp.gib(1,4)*sp.gib(1,4),1,4,Nenner);
    G.Berechne(Nenner*sp.gib(1,5)*sp.gib(1,5),1,5,Nenner);
    G.Berechne(Nenner*sp.gib(1,6)*sp.gib(1,6),1,6,Nenner);
    G.Berechne(Nenner*sp.gib(2,3)*sp.gib(2,3),2,3,Nenner);
    G.Berechne(Nenner*sp.gib(2,4)*sp.gib(2,4),2,4,Nenner);
    G.Berechne(Nenner*sp.gib(2,5)*sp.gib(2,5),2,5,Nenner);
    G.Berechne(Nenner*sp.gib(2,6)*sp.gib(2,6),2,6,Nenner);
    G.Berechne(Nenner*sp.gib(3,4)*sp.gib(3,4),3,4,Nenner);
    G.Berechne(Nenner*sp.gib(3,5)*sp.gib(3,5),3,5,Nenner);
    G.Berechne(Nenner*sp.gib(3,6)*sp.gib(3,6),3,6,Nenner);
    G.Berechne(Nenner*sp.gib(4,5)*sp.gib(4,5),4,5,Nenner);
    G.Berechne(Nenner*sp.gib(4,6)*sp.gib(4,6),4,6,Nenner);
    G.Berechne(Nenner*sp.gib(5,6)*sp.gib(5,6),5,6,Nenner);
    System.out.println(")");



 
  }

   

}

