package Algebra;

import Brueche.Bruch;

public class GanzeZahl extends Koerper {


//Initilalisierung

  public GanzeZahl(int n) {
    super(n);
  }


//Berechnen der Konstanten

  public double[][] Koeffizienten() {
    double[][] b = new double[n][n];
    for (byte i=0; i<n; i++) //Zeile i
      for (byte j=0; j<n; j++) //Spalte j
        b[i][j] = Rechnen.hoch(NS[i],j);
    return b;
  }

  public double[][] Grenzen(double c, int Nenner) {
    double[][] a = new double[n][2];
    a[0][0] = c;
    a[0][1] = c;
    for (byte i=1; i<n; i++) {
      a[i][0] = 0;
      a[i][1] = Nenner*4;// hier ggf. die 4  mit nat. Zahl mult. (in diesem Fall 3)
    }
    return a;
  }

  public double[][][] Dreiecksformkoeffizienten() {
    double [][][] b = new double[n][n][n];
    b[0] = Koeffizienten();
    for (byte k=1; k<n; k++) //k-ter Schritt
      for (byte i=k; i<n; i++) //i-te Zeile
        for (byte j=k; j<n; j++) //j-te Spalte
          b[k][i][j] = b[k-1][i][j]-(b[k-1][k-1][j]*b[k-1][i][k-1])/b[k-1][k-1][k-1];
    return b;
  }

  public double[][][] Dreiecksformgrenzen(double c, int Nenner) {
    double [][][] a = new double[n][n][2];
    a[0] = Grenzen(c, Nenner);
    double[][][] b = Dreiecksformkoeffizienten();
    for (byte k=1; k<n; k++) //k-ter Schritt
      for (byte i=k; i<n; i++) { //i-te Zeile
          if ((b[k-1][i][k-1]/b[k-1][k-1][k-1])<0) {
            a[k][i][0] = a[k-1][i][0]-(a[k-1][k-1][0]*b[k-1][i][k-1])/b[k-1][k-1][k-1];
            a[k][i][1] = a[k-1][i][1]-(a[k-1][k-1][1]*b[k-1][i][k-1])/b[k-1][k-1][k-1];
          }
          else {
            a[k][i][0] = a[k-1][i][0]-(a[k-1][k-1][1]*b[k-1][i][k-1])/b[k-1][k-1][k-1];
            a[k][i][1] = a[k-1][i][1]-(a[k-1][k-1][0]*b[k-1][i][k-1])/b[k-1][k-1][k-1];
          }
      }
    return a;
  }

  public void Berechne(double g, int eins, int zwei, int Nenner) {
    double[][][] a = Dreiecksformgrenzen(g, Nenner);
    double[][][] b = Dreiecksformkoeffizienten();
    double[][] c = new double[2][];
    long[] ganzUnten = new long[n];
    long[] ganzOben = new long[n];
    long[] L = new long[n];
    double Summe = 0.0;
    int k = n-1;
  BlockZ:
    while (k<n && k>=0) { //z(n-1) bis z0
      c[0] = new double[n-k];
      c[1] = new double[n-k];
      for (int j=n-1; j>=k; j--) { //c(n-1) bis ck
        Summe = 0.0;
        for (int i=n-1; i>k; i--)
          Summe = Summe + b[k][j][i] * L[i];
        if (b[k][j][k] > 0) {
          c[0][n-1-j] = (a[k][j][0] - Summe)/b[k][j][k]; //c[n-1-j] := cj
          c[1][n-1-j] = (a[k][j][1] - Summe)/b[k][j][k];
        }
        else {
          c[0][n-1-j] = (a[k][j][1] - Summe)/b[k][j][k];
          c[1][n-1-j] = (a[k][j][0] - Summe)/b[k][j][k];
        }
      }
      double unten = Rechnen.max(c[0]);
      double oben = Rechnen.min(c[1]);
      ganzUnten[k] = new Double(Math.ceil(unten)).longValue();
      if (ganzUnten[k] > unten + 0.99)
        ganzUnten[k] = ganzUnten[k] - 1;
      ganzOben[k] = new Double(Math.floor(oben)).longValue();
      if (ganzOben[k] < oben - 0.99)
        ganzOben[k] = ganzOben[k] + 1;
      L[k] = ganzUnten[k];
      if (k==0)
        while (L[0] <= ganzOben[0]) {
          for (byte r=0; r<n; r++)
            System.out.print(L[r]+"rho^"+r+"+");
          L[0]++;
        }
      while (L[k] > ganzOben[k]) {
        k++;
        if (k>=n)
          break BlockZ;
        L[k]++;
      }
      k--;
    }
  }


}
