package Algebra;

import Brueche.Bruch;

public class Rechnen {

  public static double hoch(double x, long n) {
    double Ergebnis = 1.0;
    if (n>=0)
      for (long j=1; j<=n; j++)
        Ergebnis *= x;
    else
      for (long j=1; j<=-n; j++)
        Ergebnis *= 1.0/x;
    return Ergebnis;
  }

  public static double max(double[] Argument) {
    double Ergebnis = Argument[0];
    for (int i=1; i<Argument.length; i++)
      if (Ergebnis < Argument[i])
        Ergebnis = Argument[i];
    return Ergebnis;
  }

  public static double min(double[] Argument) {
    for (int i=0; i<Argument.length; i++)
      Argument[i] = -Argument[i];
    return -Rechnen.max(Argument);
  }

  public static int max(int x, int y) {
    if (x<y)
      return y;
    else
      return x;
  }

  public static int min(int x, int y) {
    return -Rechnen.max(-x, -y);
  }

  public static Bruch[] BruchPolynomAdd(Bruch[] x, Bruch[] y) {
    int max = max(x.length, y.length);
    int min = -max(-x.length, -y.length);
    Bruch[] z = new Bruch[max];
    for (int i=0; i<min; i++)
      z[i] = Bruch.add(x[i], y[i]);
    for (int i=min; i<max; i++)
      if (max == x.length)
        z[i] = new Bruch(x[i].Zaehler(), x[i].Nenner());
      else
        z[i] = new Bruch(y[i].Zaehler(), y[i].Nenner());
    return z;
  }

  public static Bruch[] BruchPolynomMult(Bruch[] x, Bruch[] y) {
    Bruch[] z = new Bruch[x.length+y.length-1];
    for (int h=0; h<x.length+y.length-1; h++)
      z[h] = new Bruch(0,1);
    for (byte i=0; i<x.length; i++)
      for (byte j=0; j<y.length; j++)
        z[i+j] = Bruch.add(z[i+j], Bruch.mult(x[i], y[j]));
    return z;
  }

  public static double[] MM(double[] a, double[] b) {
    double[] Ergebnis = new double[4];
    Ergebnis[0] = a[0]*b[0]+a[1]*b[2];
    Ergebnis[1] = a[0]*b[1]+a[1]*b[3];
    Ergebnis[2] = a[2]*b[0]+a[3]*b[2];
    Ergebnis[3] = a[2]*b[1]+a[3]*b[3];
    return Ergebnis;
  }

  public static double Trace(double[] Matrix) {
    double Ergebnis = Matrix[0]+Matrix[3];
    return Ergebnis;
  }

  public static double[] inv(double[] a) {
    double[] Ergebnis = new double[4];
    Ergebnis[0] = a[3];
    Ergebnis[1] = -a[1];
    Ergebnis[2] = -a[2];
    Ergebnis[3] = a[0];
    return Ergebnis;
  }


}
